var fontArray ;
var currentFontPos = 0;
var HKLM = 0x80000002;
var debugFlg = 1;

//===========================================
// this function runs on startup
//===========================================
function widgetOnLoad() {
    if (debugFlg == 1) {print ("%-I-INFO, startup")};
    getPrefs();                       // set the preferences - required by Xwidget as it has no native prefs
    ShowFontList();
    fontPreferences.visible = true;
}
//=====================
//End function
//=====================

//=================================
// Function to get the fonts from the registry
//=================================
function ShowFontList(){
    if (debugFlg == 1) {print ("%-I-INFO, ShowFontList")};

var tmpFontArray ;
// Get an instance of the StdRegProv class...
var objService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\default");
var objReg = objService.Get("StdRegProv");

// Prepare the EnumKey method...
var objMethod = objReg.Methods_.Item("EnumValues");
var objParamsIn = objMethod.InParameters.SpawnInstance_();
objParamsIn.hDefKey = HKLM;
objParamsIn.sSubKeyName = "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Fonts\\";

// Execute the method and collect the output...
var objParamsOut = objReg.ExecMethod_(objMethod.Name, objParamsIn);

// If successful, iterate the subkeys...
if (objParamsOut.ReturnValue === 0) {
    if (objParamsOut.sNames != null) {
        tmpFontArray = objParamsOut.sNames.toArray(); //populate the temporary array
        for (var i = 0; i < tmpFontArray.length; ++i) {
            if  ( trim(tmpFontArray[i]) == "" || tmpFontArray[i].lastIndexOf("Bold") != -1 || tmpFontArray[i].lastIndexOf("Italic") != -1 )  {
                tmpFontArray[i] = "";    //exclude certain font entries
            } else {
                tmpFontArray[i] = trim(tmpFontArray[i].substring(0,tmpFontArray[i].lastIndexOf("(TrueType)")));
            }
        }
    }
}
        //populate the final array and sort it
        fontArray=[];
        var j = 0;
        for (var i = 0; i < tmpFontArray.length; ++i) {
            if (trim(tmpFontArray[i]) != "" ) {
               fontArray[j] = tmpFontArray[i];
               j = j + 1;
            }
        }
        fontArray.sort();
}
//=================================
// end function
//=================================




function preferencesPopupPanelFontOnMouseWheelDown(Sender)
{
      //if (debugFlg == 1) {print ("%-I-INFO, preferencesPopupPanelFontOnMouseWheelDown")};
       currentFontPos = currentFontPos + 1;
       if (currentFontPos >= fontArray.length ) {currentFontPos = fontArray.length};
       if (fontArray[currentFontPos] != null) {
        preferencesPopupPanelFont.text = fontArray[currentFontPos];
        preferencesPopupPanelFont.Font.Family = preferencesPopupPanelFont.text;
       }
}

function preferencesPopupPanelFontOnMouseWheelUp(Sender)
{
       currentFontPos = currentFontPos - 1;
       if (currentFontPos <=0 ) {currentFontPos = 0};
       if (fontArray[currentFontPos] != null) {
          preferencesPopupPanelFont.text = fontArray[currentFontPos];
          preferencesPopupPanelFont.Font.Family = preferencesPopupPanelFont.text;
       }
}


function preferencesPopupPanelFontOnKeyDown(Sender,Key,KeyChar,Shift)
{
  //print(Key);
  if (Key == 13) {
     button7OnMouseDown();
  };
}


function fontProgressbarOnChange(Sender)
{
  var fontTmpSize = parseInt((19 /100 * fontProgressbar.Percent) + 9);
  preferencesPopupPanelFontSizePrefValue.text = fontTmpSize;
  preferencesPopupPanelFont.font.size = preferencesPopupPanelFontSizePrefValue.text;
}

function cancelButtonOnClick(Sender)
{
 fontPreferences.visible = false;
 widget.Close;
}

//=========================================================================
// this function saves the preferences to an ini file for later use
//=========================================================================
function saveButtonOnClick(Sender)
{
         fontPreferences.visible = false;
         SavePrefs();
         widget.close;
         //widgetOnLoad();
}
//=====================
//End function
//=====================


//=========================================================================
// this function saves the preferences to an ini file for later use
//=========================================================================
function SavePrefs()
{
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesPopupPanelFontSizePrefValue", preferencesPopupPanelFontSizePrefValue.text);
         Setinivalue(widgetpath+"prefs.ini","prefs","fontProgressbar", fontProgressbar.percent);
         Setinivalue(widgetpath+"prefs.ini","prefs","preferencesPopupPanelFont", preferencesPopupPanelFont.text);
}
//=====================
//End function
//=====================

                
//=========================================================================
// this function sets the preference values to saved values
//=========================================================================
function getPrefs() {
    preferencesPopupPanelFontSizePrefValue.text =  Getinivalue(widgetpath+"prefs.ini","prefs","preferencesPopupPanelFontSizePrefValue","17");
    fontProgressbar.percent =  Getinivalue(widgetpath+"prefs.ini","prefs","fontProgressbar","17");
    preferencesPopupPanelFont.text =  Getinivalue(widgetpath+"prefs.ini","prefs","preferencesPopupPanelFont","times new roman");
}
//=====================
//End function
//=====================


